# wxc-fold-list

> 折叠列表

## Code Example

```vue
<!-- CopyRight (C) 2017-2022 Alibaba Group Holding Limited. -->
<template>
  <div class="wxc-demo">
    <scroller class="scroller">
      <title title="wxc-lc-fold-list"></title>
      <category title="折叠列表"></category>

      <lc-fold-list
        :fold-left-text="'折叠列表测试'"
        :fold-right-text="'更多'"
        @fold="processFold"
      >
        <div slot="foldContent">
          <text>hello</text>
        </div>
      </lc-fold-list>

      <lc-fold-list
        :fold-left-text="'折叠列表测试2'"
        :fold-right-text="'更多2'"
        @fold="processFold"
      >
        <div slot="foldContent">
          <text>这是另外一个折叠列表</text>
        </div>
      </lc-fold-list>
    </scroller>
  </div>
</template>

<style scoped>
  .wxc-demo {
    position: absolute;
    top: 0;
    right: 0;
    left: 0;
    bottom: 0;
    background-color: #fff;
  }

  .scroller {
    flex: 1;
  }
</style>

<script>
  import Title from '../_mods/title.vue';
  import Category from '../_mods/category.vue';
  import  LcFoldList from '../../packages/lc-fold-list';
  import { setTitle } from '../_mods/set-nav';

  export default {
    components: { Title, Category, LcFoldList },
    methods:{
      processFold(fold){
        console.log(fold)
      }
    }
  }
</script>

```


### API


### Event
