# lc-passwordfield

> 带有显示/隐藏密码功能的输入框

## [Demo](http://res.lightyy.com/lightui/example/passwordfield/?_wx_tpl=http%3A%2F%2Fres.lightyy.com%2Flightui%2Fexample%2Fpasswordfield%2Findex.native.js)

<img src="./passwordfield.png" width="240"/>
<img src="./passwordfield-scan.png" width="160">

## 使用方法

```vue
<template>
  <div class="wxc-demo">
    <title title="lc-passwordfield"></title>

    <div class="container">

      <category title="密码输入域(默认不显示密码)"></category>
      <div class="form">
        <lc-passwordfield type="password" :autofocus="true"></lc-passwordfield>
      </div>

      <category title="密码输入域(显示密码)"></category>
      <div class="form">
        <lc-passwordfield type="password" :pwdShow="true" ></lc-passwordfield>
      </div>

    </div>

  </div>
</template>

<style scoped>
  .wxc-demo {
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background-color: #FFFFFF;
  }
  .container{
    flex-direction: column;
    align-items: center;
  }
  .form{
    width: 600px;
  }
</style>

<script>
  import { LcPasswordfield } from '../../index';
  import Title from '../_mods/title.vue';
  import Category from '../_mods/category.vue';

  export default {
    components: { Title, Category, LcPasswordfield },
    data: () => ({
    }),
    created () {
    },
    methods: {
    }
  };
</script>



```

### API
| Prop | Type | Required | Default | Description |
| ---- |:----:|:---:|:-------:| :----------:|
| **`placeholder`** | `String` | `N` | ` ` | `提示文本` |
| **`disabled`** | `Boolean` | `N` | `false` | `是否禁用` |
| **`autofocus`** | `Boolean` | `N` | `false` | `是否自动聚焦` |
| **`maxlength`** | `Number` | `N` | ` ` | `输入最大长度` |
| **`pwdShow`** | `Boolean` | `N` | `false` | `密码是否显示` |

