# lib-modal

A modal displays content that temporarily blocks interactions with the main view of a site. This lib temporarily support alert, confirm and prompt. Also there's a toast method to display a short info, which is not technically a modal.

## install

``npm install modals --save``

## usage

### toast

```
modal.toast('just a toast', 2)
```

![a toast](http://gw.alicdn.com/mt/TB1vmHrLFXXXXajXXXXXXXXXXXX-309-219.png)

### alert

```
modal.alert({
  message: 'just a alert',
  callback: function () {
    console.log('callback')
  },
  okTitle: 'good'
})
```

![alert](http://gw.alicdn.com/mt/TB133u6LFXXXXaiaXXXXXXXXXXX-349-266.png)

### confirm

```
modal.confirm({
  message: 'confirm this info',
  callback: function (val) {
    console.log('callback', val)
  },
  okTitle: 'good',
  cancelTitle: 'bad'
})
```

![confirm](http://gw.alicdn.com/mt/TB1nh_XLFXXXXbqXVXXXXXXXXXX-354-256.png)

### prompt

```
modal.prompt({
  message: 'input sth.',
  callback: function (val) {
    console.log('input value is: ' + val)
  },
  okTitle: 'good',
  cancelTitle: 'bad'
})
```
![prompt](http://gw.alicdn.com/mt/TB1Z6YuLFXXXXahXXXXXXXXXXXX-351-304.png)

## api

#### toast(message[, duration])

* ``message``: toast content.
* ``duration``: seconds to display (default is 0.8 seconds).

#### alert(config)

* ``message``: message to display in content box.
* ``okTitle``: title of the ok button (default is OK).
* ``callback``: it will pass nothing to this callback function.

#### confirm(config)

* ``message``: message to display in content box.
* ``okTitle``: title of the ok button (default is 'OK').
* ``cancelTitle``: title of the cancel button (default is 'Cancel').
* ``callback``: it will pass a string to this callback function, which is either the value of okTitle or the cancelTitle.

#### prompt(config)

* ``message``: message to display in content box.
* ``okTitle``: title of the ok button (default is 'OK').
* ``cancelTitle``: title of the cancel button (default is 'Cancel').
* ``callback``: it will pass a object to this callback function, which has two attributes:
  * ``result``: either the value of okTitle or cancelTitle.
  * ``data``: the string user inputted.

## License

(The MIT License)

Copyright (c) 2016 Alibaba MFE

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
